;Assemblieren mit
;a86 mim.asm  liefert mim.com Programm
;mit dem man wie mit mode die COM-Schnittstellen einstellen kann,
;aber mit allen Baudraten, auerdem ist es kleiner

;Macrodefinitionen

allpush macro
 push bx
 push cx
 push dx
 push bp
 push di
 push si
#em

allpop macro
 pop  si
 pop  di
 pop  bp
 pop  dx
 pop  cx
 pop  bx
#em

negdxbx macro
 not  bx
 not  dx
 add  bx,1
 adc  dx,0
#em

;setzt ein Prozessorregister auf 0, z.B.  clr ax
;!Achtung!, beeinflut auch das C-Flag
clr macro
 xor #1,#1
#em

pushdxbx macro
 push dx
 push bx
#em

popdxbx macro
 pop  bx
 pop  dx
#em

popcxax macro
 pop  ax
 pop  cx
#em

mov_esds macro
 mov  bp,ds
 mov  es,bp
#em

movs4w macro ;ist nur 4 Byte lang, also krzer als mov cx,... rep...
 movsw
 movsw
 movsw
 movsw
#em

;Einige Routinen in diesem Quelltext sind mit #if #endif
;ausgeklammert. Sie werden nicht bentigt, aber als Grundlage
;fr spteres im Text belassen. Sie werden nicht bersetzt, da
;keine Marke erweit1 definiert ist.


 org 0100h ;Standard-Startadresse fr *.COM-Files

;Eintritt mit CS = DS = ES = SS,
;SP zeigt auf das letzte verfgbare word in diesem Segment

START:
 cmp sp,prgende+0400h ;mind. 1KByte Stack sollte frei sein
 jb p_ende            ;zuwenig Speicher, sofort Ende
 mov sp,prgende+0400h ;neuer Stack
 mov bx,sp
 mov cl,04h
 shr bx,cl   ;Byteanzahl -> Paragraphen
 add bx,02h  ;zur Sicherheit
 mov ah,04ah ;ntigen Platz reservieren, Rest freigeben
 int 021h    ;INT$21 Func$4A: setze Speicherblock
 jc p_ende   ;darf nie auftreten

#if erweit1

 mov bx,0ffffh
 mov ah,048h ;wieviel Speicher ist frei ?
 int 021h    ;INT$21 Func$48: Speicherbereich zuweisen
 cmp bx,0400h
 jb p_ende   ;unter 16Kbyte = $4000 Byte will ich nicht
 cmp bx,01000h
 jb start1   ;aber mehr als 64KByte = $10000 auch nicht
 mov bx,01000h
start1:
 mov ah,048h ;Speicher holen
 int 021h
 jc p_ende   ;darf nicht auftreten
 mov w[PUFADR],0 ;Pufferadresse als FARPTR
 mov [PUFADR+2],ax
 shl bx,1    ;Paragraphen -> Byteanzahl
 shl bx,1
 shl bx,1
 shl bx,1
 or bx,bx
 jnz start2
 dec bx      ;statt $10000 gleich $ffff nehmen
start2:
 mov [PUFLEN],bx ;Pufferlnge in Byte

#endif

 call arbeit     ;eigentliches Programm

#if erweit1

 mov es,[PUFADR+2]
 mov ah,049h     ;Speicher freigeben
 int 021h        ;INT$21 Func$49: Speicherbereich freigeben

#endif

p_ende:
 mov ax,04c00h ;Programm beenden
 int 021h      ;INT$21 Func$4C: beende Programm


Meldungen:
msg1: db 'Small mode for COM-ports, (C) by SWB, 1994-10-14',0dh,0ah,0
msgbper: db 'Bad/impossible parameters. I need:',7,0dh,0ah
	 db 'baudrate bits/char paritymode stopbits',0dh,0ah,0


Variablen:
hilf0: dw 0

PUFADR: dw 0,0 ;FARPTR
PUFLEN: dw 0
CCMOLD: dw 0
CCMRW: db 0
CCMMED: db 0
CCMPAGE: db 0
CCMADR: dw 0,0 ;32 Bit lineare Adresse relativ zu $C0000
CCMLEN: dw 0
FNAME: dw 0
FHAND: dw 0


arbeit:
 mov si,msg1  ;Startmeldung ausgeben
 call PRTSTG
 mov si,0080h ;die Kommandozeile des DOS
 cld          ;interpretieren, wenn sie > 2 Zeichen ist
 lodsb
 cmp al,3
 jb ar1err
 mov ah,00h
 call IGNBLNK
 lodsb
 call CCBIG
 cmp al,'?'   ;Werte der Schnittstelle anzeigen?
 jz ar1
 cmp al,'C'   ;Werte einstellen?
 jz ar1

; cmp al,'R'  ;Read, Lesen von Karte ?
; jz ar1
; cmp al,'W'  ;Write, Schreiben auf Karte ?
; jz ar1
; cmp al,'V'  ;Verify, Karte und File vergleichen ?
; jz ar1
ar1err:
 mov si,msgbper  ;Fehler, ungltiges Kommando
 jmp ar_end

ar1:
 mov [CCMRW],al

 call TSTNUM ;COM-Nummer ?
 or ch,ch
 jz ar1err
 or dx,dx    ;nur 0 bis 65535 zugelassen
 jnz ar1err  ;Fehler, unmgliche Banknummer
 or bx,bx
 jz ar1err   ;COM0 ist unmglich
 cmp bx,5
 jnc ar1err  ;COM4 ist max.
;Nummer in BX

 mov al,[CCMRW]
 cmp al,'?'
 jnz ar1c0
 jmp pshow   ;Parameter anzeigen
ar1c0:
 cmp al,'C'
 jnz ar1c1
 jmp pset    ;Parameter setzen
ar1c1: 
 jmp ar1err  ; ********* ERSTMAL, DA NICHTS WEITER DA


pset:
;Parameter der Schnittstelle setzen
;**** erstmal immer BX als BIOS-Nummer ansehen
 mov ax,040h      ;ab 40:0 stehen die I/O-Adressen der COM1..COM4
 mov es,ax
 dec bx
 add bx,bx
 es: mov dx,[bx]
 mov_esds 
 or dx,dx
; jz FEHLER   spter mal
 mov [hilf0],dx     ;I/O-Adr sichern
 mov ah,0
 call IGNBLNK
 call TSTNUM
 or ch,ch
 jz ar1err   ;Fehler, Baudrate ist keine Zahl
 mov di,dx   ;teiler = 115200 / baudrate
 mov bp,bx
;115200=1843200/16 = 1*65536+49664
 mov dx,1
 mov bx,49664
 call DIVIL
;Runden durch Vergessen des Divisionsrestes
;BX: teiler
;Baudrate setzen
 mov dx,[hilf0]
 add dx,3     ;LCR-adr
 cli          ;INTERRUPTSPERRE
 in al,dx
 mov ch,al    ;CH: LCR
 or al,080h   ;Zugriff auf divisor latch
 out dx,al
 sub dx,3
 mov ax,bx
 out dx,ax
 mov al,ch
 add dx,3
 out dx,al    ;Zugriff auf alten Wert
 sti          ;Interrupts frei
;Baue ein LCR zusammen in CH
 mov ch,3     ;default 8n1
;Anzahl Datenbits auswerten
 mov ah,0
 call IGNBLNK
 lodsb
 sub al,'5'   ;5 -> 0, max 8
 jc ar2err    ;Fehler, <5 (oder Mll)
 cmp al,4
 jnc ar2err   ;Fehler, >8 (oder Mll)
 mov ch,al
 mov ah,0
 call IGNBLNK
 lodsb
 call CCBIG
 cmp al,'N'
 jz pse_1
 or ch,8      ;enable parity (odd) 
 cmp al,'O'
 jz pse_1
 or ch,010h   ;parity enabled + even
 cmp al,'E'
 jnz ar2err   ;Fehler, Parity-Angabe falsch
pse_1:
 mov ah,0
 call IGNBLNK
 lodsb
 cmp al,'1'
 jz pse_2
 or ch,4
 cmp al,'2'
 jnz ar2err   ;Fehler, Stoppbits falsch
pse_2:
;setze einfach so LCR, ohne vorher Sender/Empfnger zu stoppen
 mov al,ch
 mov dx,[hilf0]
 add dx,3
 out dx,al
 ret

;provisorisch
ar2err:
 jmp ar1err


pshow:
;Parameter der Schnittstelle anzeigen
;**** erstmal immer BX als BIOS-Nummer ansehen
 mov ax,040h      ;ab 40:0 stehen die I/O-Adressen der COM1..COM4
 mov es,ax
 dec bx
 add bx,bx
 es: mov dx,[bx]
 mov_esds 
 or dx,dx
; jz FEHLER   spter mal
 add dx,3     ;LCR-adr
 cli          ;INTERRUPTSPERRE
 in al,dx
 mov ch,al    ;CH: LCR
 or al,080h   ;Zugriff auf divisor latch
 out dx,al
 sub dx,3
 in ax,dx
 mov bp,ax    ;BP: divisor latch komplett
 mov al,ch
 add dx,3
 out dx,al    ;Zugriff auf alten Wert
 sti          ;Interrupts frei
 push ax      ;LCR-Inhalt fr spter
;115200=1843200/16 = 1*65536+49664
 sub di,di
 mov dx,1
 mov bx,49664
 call DIVIL
;Runden der Ausgabe durch Vergessen des Divisionsrestes
 mov cl,7
 call PRTNUM
 mov al,' '
 call CHROUT
 pop bx       ;LCR-Inhalt
 mov al,bl
 and al,3
 add al,'5'
 call CHROUT
 mov al,'S'
 test bl,020h
 jz psh_1
;*** bei "stick" Parity, also festem Parittsbit, 'S' als
;*** Hinweis, o bedeutet dann pbit=1 ("ungerade")
 call CHROUT
psh_1:
 mov al,'n'
 test bl,008h
 jz psh_0
 mov al,'o'
 test bl,010h
 jz psh_0
 mov al,'e'
psh_0:
 call CHROUT
;man muss selbst wissen, dass 5?2 eigentlich 5?1.5 bedeutet
 mov al,004h
 and al,bl
 shr al,1
 shr al,1
 add al,'1'
 call CHROUT
 call CRLF
 ret




ar_end:
 call PRTSTG
 ret


IGNBLNK:
;incr. SI soweit (falls berhaupt), bis es nicht mehr auf Spaces zeigt
;incr. SI nochmal, falls es auf Suchzeichen zeigte
;in:  SI: Textzeiger
;     AH: Suchzeichen
;out: SI: Textzeiger
;     AL: Textzeichen auf das SI zeigt
;     Flags: von CMP Zeichen,Suchzeichen
;fre: alle anderen Register
 cld
ignblnk1:
 lodsb         ;hole Zeichen
 cmp  al,020H
 jz   ignblnk1 ;berspringe Spaces
 cmp  al,ah    ;Suchzeichen gefunden ?
 jnz  ignblnk2 ; nein, SI zeigt hinter Space
 lodsb         ; ja, nchstes Zeichen holen
ignblnk2:      ;SI zeigt eins zu weit!
 lahf
 dec  si
 sahf
 ret




TSTNUM:
;teste ob der Text eine 32Bit-Integer-Zahl ist, wenn ja wandle ihn
;in:  SI: Textzeiger
;out: SI:  -"- hinter Zahl
;     DXBX: gewandelte Zahl
;     CH: $00=keine_Zahl,  $01=dezimal,  $80=hexadezimal
;fre: DI
 clr  bx      ;DXBX=0
 clr  dx
 clr  cx
 mov  ah,'$'  ;Hexzahl ?
 call IGNBLNK ;Spaces berlesen, erledigt auch cld
 jnz  tnumd0
;Hexzahl wandeln
tnumh2:
 lodsb
 call TSTZIF ;Ziffer 0 bis 9 ?
 jnc  tnumh1 ; ja
 call CCBIG  ;in Grobuchstaben
 cmp  al,'A'
 jb   tnumh4 ;zu klein
 cmp  al,'F'
 ja   tnumh4 ;zu gro
 sub  al,'A'-10 ;'A' bis 'F' nach $A bis $F
tnumh1:
 mov  cx,4
tnumh5:
 sal  bx,1
 rcl  dx,1
 loop tnumh5
 or   bl,al
 jmp  tnumh2
tnumh4:
 dec  si
 mov  ch,080h   ;es war eine Hexzahl
tnumh6:
 ret

tnumd0:
;Dezimalzahl wandeln
 mov  ah,'-'  ;negatives Vorzeichen ?
 call IGNBLNK
 push di
 pushf        ;Flag dafr sichern
 sub sp,8     ;Platz
 mov bp,sp    ;als Zwischenspeicher
 clr  ax
 mov  di,bp   ;auf 0 setzen
 mov  cx,4
 rep stosw    ;b[bp]: Zahl gltig-Flag
tnumd1:
 lodsb
 call TSTZIF  ;teste ob Ziffer
 jc   tnumd2  ; nein
 mov  b[bp],0afh ;Dezimal-Integer
 mov  cx,4    ;altes *10
tnumd10:
 shl  w[bp+2],1 ;Sammlung als BCD-Kode in w[BP+6]w[BP+4]w[BP+2]
 rcl  w[bp+4],1
 rcl  w[bp+6],1 ;alles ber 12(!) Stellen fllt automatisch raus
 loop tnumd10
 or   b[bp+2],al ;Ziffer einfgen
 jmp  tnumd1    ;alle Ziffern sammeln
tnumd2:
 cmp  b[bp+6],021h ;wenn >2147483647, lsche hchste Ziffer
 jb   tnumd3    ;fr Integer nur 10 Stellen:
 ja   tnumd4    ; b[BP+6]w[BP+4]w[BP+2]
 cmp  w[bp+4],04748h
 jb   tnumd3
 ja   tnumd4
 cmp  w[bp+2],03647h
 jbe  tnumd3
tnumd4:
 and  b[bp+6],0fh
tnumd3:
 clr  bx ;wandle die BCD-Zahl in binr
 clr  dx
 mov  ch,10 ;10 Stellen
tnumd5:
 mov  cl,9
 mov  ax,bx
 mov  di,dx
tnumd6:
 add  bx,ax ;DXBX=DXBX*10
 adc  dx,di
 dec  cl
 jnz  tnumd6
 mov  cl,4
 clr  ax
tnumd7:
 shl  w[bp+2],1 ;1 Digit holen
 rcl  w[bp+4],1
 rcl  b[bp+6],1
 rcl  ax,1
 dec  cl
 jnz  tnumd7
 add  bx,ax   ;dazuaddieren
 adc  dx,0
 dec  ch
 jnz  tnumd5  ;alle 10 Digits
 mov  ch,[bp+0] ;Flag fr Gltigkeit
 mov  b[bp+1],0 ;Zahlentyp: 32 Bit Integer
 add sp,8    ;Stackplatz freigeben
 popf        ;Flag ob - Vorzeichen
 jnz  tnumd8 ;nein
 negdxbx     ;DXBX=-DXBX
tnumd8:
 pop  di
 dec  si
 ret


TSTZIF:
;wenn AL = '0' bis '9' dann AL = 0 bis 9, Flag NC
;sonst AL unverndert, Flag C
 cmp  al,'0'
 jc   ret
 cmp  al,'9'+1
 cmc
 jc   ret
 sub  al,'0' ;lscht C-Flag
 ret


CCBIG:
;konvertiert 'a'-'z' in 'A'-'Z' in Register AL
 cmp  al,'a'
 jb   ret
 cmp  al,'z'
 ja   ret
 sub  al,020h
 ret


PRTSTG:
;Druckt einen Text bis zu einem $00 (wird nicht gedruckt) aus.
;in:  SI: Zeiger auf Text
;out: SI: Zeiger hinter Text ($00)
;frei: BX, CX, DX, BP, DI
 cld
 lodsb       ;Zeichen holen in AL
 or   al,al  ;wenn $00 gefunden: Ende
 jz   prtstg2
 call CHROUT ;Zeichen drucken
 jmp  PRTSTG
prtstg2:
 ret




PRTNUM:
;druckt die vorzeichenbehaftete Zahl aus DXBX rechtsjustiert
;in der in CL angegebenen Anzahl Spaces
;sollten es zu wenig Spaces sein, wird Zahl einfach so gedruckt
;falls CL>128, so wird eine Hexzahl mit CL-128 Ziffern gedruckt
;falls CL=128, Hexzahl ohne fhrende Nullen
;in:  DXBX: Zahl
;     CL: Anzahl der Spaces
 or   cl,cl
 js   PRTH   ;Hexzahl drucken
;Dezimal Integer drucken
 mov  ax,10
 push ax     ;10 als Ende-Flag
 clr  ch     ;CH: 0
 dec  cl     ;CL: Spaces
 or dx,dx    ;teste Vorzeichen
 jns  pnumd1 ;kein Vorzeichen, CH=0
 mov  ch,'-'
 dec  cl     ;'-' braucht Platz
 negdxbx     ;Betrag bilden
pnumd1:
 mov  bp,10  ;Divisor =10 (bleibt bei DIVIL erhalten)
 clr  di
pnumd2:
 push cx     ;sign and spaces
 call DIVIL  ;DXBX=DXBX/DIBP,  CXAX=Rest
 pop  cx     ;sign and spaces
 push ax     ;sichere eine Ziffer (0 bis 9)
 mov  ax,bx  ;nur noch fhrende 0en ?
 or   ax,dx
 jz   pnumd3 ; ja, hchste Ziffer <>0 schon bearbeitet
 dec  cl     ;dekrementiere Spaces
 jmp  pnumd2
pnumd3:
 dec  cl
 js   pnumd4 ;keine (weiteren) Spaces
 mov  al,' ' ;Space ausgeben
 call CHROUT
 jmp  pnumd3
pnumd4:
 mov  al,ch  ;nur '-' drucken, sonst nichts
 or   al,al
 jz   pnumd5
 call CHROUT
pnumd5:
 pop  ax
 cmp  al,10  ;Ziffer ?
 jae  pnumd6 ; nein, Endeflag (10)
 add  al,'0' ;Ziffer in ASCII
 call CHROUT ;drucken
 jmp  pnumd5 ;alle Ziffern ausgeben
pnumd6:
 ret


PRTH:
;wie PRTNUM, aber Hex mit $ davor
;CL-128: Anzahl der Hexziffern (max. werden 8 gedruckt)
;CL=128: Hexzahl ohne fhrende Nullen
 MOV  AL,'$'
 CALL CHROUT
 SUB  CL,080H
 MOV  CH,8
PRTH3:
 mov  al,03h   ;ASCII-Zeichen '0' 4*rechtsverschoben
 push cx
 mov  cx,4
prth4:
 shl  bx,1
 rcl  dx,1
 rcl  al,1
 loop prth4
 pop  cx
 CMP  AL,'9'
 jbe  PRTH1
 ADD  AL,7
PRTH1:
 or   cl,cl
 jnz  prth5
 cmp  ch,1   ;fhrende Nullen bergehen
 jz   prth6  ;aber letzte 0 drucken
 cmp  al,'0'
 jz   prth2
 mov  cl,255 ;Ende der fhrenden 0en
prth5:
 CMP  CL,CH
 jc   prth2  ;Ziffer noch nicht ausgeben
prth6:
 CALL CHROUT
prth2:
 DEC  CH
 JNZ  PRTH3
 RET



DIVIL:
;32 Bit unsigned Division
;DXBX = DXBX / DIBP
;CXAX = Rest
;unverndert: SI, DIBP
 push si
 clr  si
 clr  ax
 mov  cx,32  ;fr 32 Bit
divil0:
 shl  bx,1
 rcl  dx,1
 rcl  ax,1
 rcl  si,1
 sub  ax,bp
 sbb  si,di
 jc   divil1
 or   bl,1
 loop divil0 ;zwei Schleifenenden sind
 mov  cx,si
 pop  si
 ret
divil1:
 add  ax,bp
 adc  si,di
 loop divil0 ; etwas schneller als ein Ende
 mov  cx,si
 pop  si
 ret


#if erweit1

MULTL:
;32 Bit unsigned Multiplikation
;DXBX = DXBX * DIBP
;C-Flag bei berlauf gesetzt, sonst NC
;unverndert: SI
 mov  cx,dx  ;gerechnet wird dxbx=cxbx*dibp
 or   cx,cx  ;CX*DI wird gespart, da es null sein mu
 jz   multl0 ; sonst sowieso berlauf, es wird getestet,
 or   di,di  ; ob wenigstens ein Faktor 0 ist, sonst
 jnz  multl1 ; Fehlermeldung
multl0:
 mov  ax,di  ;DI*BX, Highword mu null werden
 mul  bx     ; sonst Zahl zu gro, die CPU setzt C-Flag
 jc   multl1 ; DI = Teilergebnis (Bit31-16)
 mov  di,ax
 mov  ax,cx  ;BP*CX, Highword mu null werden
 mul  bp     ; sonst Fehlermeldung Zahl zu gro
 jc   multl1 ; DI = Summe der ersten Teilergebnisse
 add  di,ax  ; (Bit31-16), Fehler wenn hier C-Flag gesetzt
 jc   multl1
 mov  ax,bp  ;BP*BX, darf 32Bit ergeben
 mul  bx
 add  dx,di  ;DXAX = Ergebnis
 jc   multl1 ; mehr als 32Bit
 mov  bx,ax  ;nach DXBX
 clc
 ret
multl1:
 stc
 ret


#endif


CRLF:
;erzeugt Carriage Return und Line Feed
 mov  al,0dh
 call CHROUT
 mov  al,0ah
 call CHROUT
 ret


CHROUT:
;gibt das Byte aus AL aus
;Alle Register bleiben erhalten
 push ax
 allpush
 mov dl,al
 mov ah,02h
 int 021h   ;INT$21 Func$02: Zeichen ausgeben
 allpop
 pop  ax
 ret


#if erweit1

GETKEY:
;wartet auf Tastendruck und liefert den ASCII-Code in AL (AH=0)
;ist es ein erweiterter Code, ist AL=0 und Code in AH
 allpush
 mov  ah,7
 int  021h    ;INT$21 Func$07: Zeichen lesen von Standard-Eingabe
 sub  ah,ah
 or   al,al
 jnz  getkey1 ;kein erweiterter Tastencode
 mov  ah,7
 int  021h    ;INT$21 Func$07:
 mov  ah,al
 sub  al,al
getkey1:
 allpop    ;erweiterter Code in AH, AL=0
 ret

#endif



prgende: ;mu ganz am Ende stehen

